import argparse
from pathlib import Path

from . import action


def load_parse(subparsers):
    subparser: argparse.ArgumentParser = subparsers.add_parser("client")

    subparser.add_argument("-H", "--host", dest="hostname", type=str, default="127.0.0.1")
    subparser.add_argument("-P", "--port", dest="port", type=int, default=57823)
    subparser.add_argument("-cc", "--certificate", dest="certificate", type=Path, required=False)

    subsubparsers = subparser.add_subparsers(dest="action")
    action.load_parse(subsubparsers)
